# -*- coding: utf-8 -*-
# baroslized at 2007-07-28 06:16:18

__module_name__ = 'inklchat'
__module_description__ = 'InklChat script'
__module_version__ = '0.7.4'

import xchat
import sys
import os

import time
import re


### registry entries start ###
#import _winreg, os
#
#reg_1 = '%s\\inklchat.exe' % os.getcwd()
#reg_2 = '%s\\lib' % os.getcwd()
#
#try:
#	key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, 'SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\inklchat.exe')
#	if _winreg.QueryValueEx(key, '')[0] != reg_1: raise RuntimeError
#	if _winreg.QueryValueEx(key, 'Path')[0] != reg_2: raise RuntimeError
#	key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, 'SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\inklchat.exe', 0, _winreg.KEY_SET_VALUE)
#except:
#	key = _winreg.CreateKey(_winreg.HKEY_LOCAL_MACHINE, 'SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\inklchat.exe')
#	_winreg.SetValueEx(key, '', 0, _winreg.REG_SZ, reg_1)
#	_winreg.SetValueEx(key, 'Path', 0, _winreg.REG_SZ, reg_2)
#	_winreg.FlushKey(key)
#
#	os.startfile(reg_1)
#	sys.exit()
### registry entries end ###

try: os.mkdir('scripts')
except: pass
try: os.mkdir('../scripts')
except: pass

stat = ''
need_to_join = False

def save_autojoin_list():
	data = open('../config/servlist_.conf').read()
	data = re.sub('\nJ=.*?\n', '\nJ=%s\n' % ','.join(autojoin_list), data)
	open('../config/servlist_.conf', 'w').write(data)
def load_autojoin_list():
	global autojoin_list

	data = open('../config/servlist_.conf').read()
	autojoin_list = [x.strip() for x in re.search('\nJ=(.*?)\n', data).group(1).split(',') if x.strip()]
def add_autojoin_list(chan):
	global autojoin_list
	if chan in autojoin_list: return False
	autojoin_list.append(chan)
	save_autojoin_list()
	return True
def remove_autojoin_list(chan):
	global autojoin_list
	if chan not in autojoin_list: return False
	autojoin_list.remove(chan)
	save_autojoin_list()
	return True
load_autojoin_list()

def hook_keypress(word, word_eol, userdata):
	ch = len(word) > 2 and word[2] or ''
	if ch == '\r':
		line = xchat.get_info('inputbox').strip()
		if line and on_line(line):
			xchat.command('settext  ')
			return xchat.EAT_ALL

def on_line(line):
	global stat

	if line.startswith('/'): return
	if stat in ['input_nick', 'input_chan']:
		func_start(line)
		return True
	if func_mirc_like(line):
		return True

def do_input_nick():
	global stat

	print '\x02아래에 있는 입력 상자에 닉네임을 입력하세요:\x02'

	stat = 'input_nick'

def do_input_chan():
	global stat

	print '\x02아래에 있는 입력 상자에 대화방을 입력하세요:\x02'

	stat = 'input_chan'

def func_start(line):
	global stat

	if stat == '':
		xchat.command('clear')

		print 'InklChat %s :: http://barosl.com/inklchat/' % __module_version__
		print
		print 'GUI에 자신이 없어서, 그만 이렇게 뒈고 말았습니다.'
		print

		nick = xchat.get_prefs('irc_nick1')
		if not nick:
			print '\x02InklChat\x02을 처음 실행하셨습니다.'
			print

			do_input_nick()
		elif not autojoin_list:
			do_input_chan()
		else:
			do_connect()
	elif stat == 'input_nick':
		print '>>> %s' % line
		print

		nick = line

		xchat.command('nick %s' % nick)
		xchat.command('set -quiet irc_nick1 %s' % nick)
		xchat.command('set -quiet irc_nick2 %s2' % nick)
		xchat.command('set -quiet irc_nick3 %s3' % nick)

		if not autojoin_list:
			do_input_chan()
		else:
			do_connect()
	elif stat == 'input_chan':
		if not line.startswith('#'): line = '#' + line

		print '>>> %s' % line
		print

		chan = line

		add_autojoin_list(chan)
		global need_to_join
		need_to_join = True

		do_connect()

def do_connect():
	xchat.command('server HanIRC')

def hook_welcomed(word, word_eol, userdata):
	global stat

	stat = ''

	if need_to_join:
		for chan in autojoin_list:
			if chan: xchat.command('join %s' % chan)

def hook_ctcp_version(word, word_eol, userdata):
	msg = word[3]
	if msg.startswith(':'): msg = msg[1:]
	if '!' not in word[0]: return
	nick = word[0].split('!')[0]
	if nick.startswith(':'): nick = nick[1:]
	if len(msg) >= 2 and msg[0] == '\x01' and msg[-1] == '\x01' and '!' in word[0]:
		xchat.command('NCTCP %s VERSION %s :: http://barosl.com/inklchat/' % (nick, 'InklChat %s' % __module_version__))
		return xchat.EAT_XCHAT

def func_mirc_like(line):
	seps = line.split(' ', 1)
	if not seps or  not seps[0].startswith('!'): return
	seps[0] = seps[0][1:].lower()

	if seps[0] in _mirc_like_funcs:
		word = ' '.join(seps).split(' ')
		word_eol = []
		i = 0
		while i < len(word):
			if word[i]:
				word_eol.append(' '.join(word[i:]))
				i += 1
			else: del word[i]

		_mirc_like_funcs[seps[0]](word, word_eol, None)
		return True


def cmd_autojoin(word, word_eol, userdata):
	chan = xchat.get_info('channel')
	if not chan.startswith('#'):
		print '대화방이 아닙니다'
		return xchat.EAT_XCHAT

	print '>>> /자동입장'
	if add_autojoin_list(chan):
		xchat.emit_print('Server Text', '\x02%s\x02 대화방에 자동으로 입장합니다.' % chan)
	else:
		remove_autojoin_list(chan)
		xchat.emit_print('Server Text', '\x02%s\x02 대화방에 자동으로 입장하지 않습니다.' % chan)
	return xchat.EAT_XCHAT

def cmd_join(word, word_eol, userdata):
	if len(word) <= 1:
		print '입장할 대화방을 입력하세요'
		return xchat.EAT_XCHAT

	for chan in word[1:]:
		if not chan.startswith('#'): chan = '#' + chan
		xchat.command('join %s' % chan)
	return xchat.EAT_XCHAT

def cmd_part(word, word_eol, userdata):
	if len(word) <= 1:
		chan = xchat.get_info('channel')
		if not chan.startswith('#'):
			print '퇴장할 대화방을 입력하세요'
			return xchat.EAT_XCHAT
		word.append(chan)

	for chan in word[1:]:
		if not chan.startswith('#'): chan = '#' + chan
		a = xchat.get_context()
		b = xchat.find_context(channel=chan)
		if a and b and a.get_info('network') == b.get_info('network') and a.get_info('channel') == b.get_info('channel'):
			xchat.command('close')
		else:
			xchat.command('part %s' % chan)
	return xchat.EAT_XCHAT

def cmd_exit(word, word_eol, userdata):
	xchat.command('exit')
	time.sleep(0.1)
	sys.exit()
	return xchat.EAT_XCHAT

def cmd_op(word, word_eol, userdata):
	if len(word) <= 1:
		print '대화방 관리 권한을 줄 사용자를 지정하세요. (여러 명 가능)'
		return xchat.EAT_XCHAT

	xchat.command('op '+word_eol[1])
	return xchat.EAT_XCHAT

def cmd_deop(word, word_eol, userdata):
	if len(word) <= 1:
		print '대화방 관리 권한을 뺏을 사용자를 지정하세요.'
		return xchat.EAT_XCHAT

	xchat.command('deop '+word_eol[1])
	return xchat.EAT_XCHAT

def cmd_opall(word, word_eol, userdata):
	xchat.command('mop')
	return xchat.EAT_XCHAT

def cmd_nick(word, word_eol, userdata):
	if len(word) <= 1:
		print '변경할 닉네임을 입력하세요.'
		return xchat.EAT_XCHAT

	nick = word[1]

	xchat.command('nick %s' % nick)
	xchat.command('set -quiet irc_nick1 %s' % nick)
	xchat.command('set -quiet irc_nick2 %s2' % nick)
	xchat.command('set -quiet irc_nick3 %s3' % nick)
	return xchat.EAT_XCHAT

def cmd_invite(word, word_eol, userdata):
	if len(word) <= 1:
		print '초대할 사용자를 입력하세요.'
		return xchat.EAT_XCHAT

	xchat.command('invite '+word_eol[1])
	return xchat.EAT_XCHAT

def cmd_rejoin(word, word_eol, userdata):
	xchat.command('cycle')
	return xchat.EAT_XCHAT

_mirc_like_funcs = {
	'자동입장': cmd_autojoin,
	'자동조인': cmd_autojoin,
	'자입': cmd_autojoin,
	'자조': cmd_autojoin,

	'입장': cmd_join,
	'조인': cmd_join,
	'참가': cmd_join,
	'참여': cmd_join,
	'들어가기': cmd_join,

	'퇴장': cmd_part,
	'나가기': cmd_part,

	'종료': cmd_exit,

	'옵': cmd_op,
	'디옵': cmd_deop,
	'올옵': cmd_opall,

	'닉': cmd_nick,

	'초대': cmd_invite,
}

xchat.hook_server('001', hook_welcomed)
xchat.hook_print('Key Press', hook_keypress)
xchat.hook_server('PRIVMSG', hook_ctcp_version)

help_str = '/자동입장 "특정 대화방에 자동으로 입장하도록 설정합니다."'
xchat.hook_command('자동입장', cmd_autojoin, help=help_str)
xchat.hook_command('자동조인', cmd_autojoin, help=help_str)
xchat.hook_command('자입', cmd_autojoin, help=help_str)
xchat.hook_command('자조', cmd_autojoin, help=help_str)

help_str = '/입장 "특정 대화방에 입장합니다."'
xchat.hook_command('입장', cmd_join, help=help_str)
xchat.hook_command('조인', cmd_join, help=help_str)
xchat.hook_command('참가', cmd_join, help=help_str)
xchat.hook_command('참여', cmd_join, help=help_str)
xchat.hook_command('들어가기', cmd_join, help=help_str)

help_str = '/퇴장 "특정 대화방에서 퇴장합니다."'
xchat.hook_command('퇴장', cmd_part, help=help_str)
xchat.hook_command('나가기', cmd_part, help=help_str)

help_str = '/종료 "IRC를 종료합니다."'
xchat.hook_command('종료', cmd_exit, help=help_str)

help_str = '/옵 "특정 사용자에게 대화방 관리 권한을 줍니다."'
xchat.hook_command('옵', cmd_op, help=help_str)
help_str = '/디옵 "특정 사용자에게서 대화방 관리 권한을 뺏습니다."'
xchat.hook_command('디옵', cmd_deop, help=help_str)
help_str = '/올옵 "모든 사용자에게 대화방 관리 권한을 줍니다."'
xchat.hook_command('올옵', cmd_opall, help=help_str)

help_str = '/닉 "닉네임을 변경합니다."'
xchat.hook_command('닉', cmd_nick, help=help_str)

help_str = '/초대 "특정 사용자를 대화방으로 초대합니다."'
xchat.hook_command('초대', cmd_invite, help=help_str)

help_str = '/재입장 "현재 대화방에서 퇴장한 후 다시 입장합니다."'
xchat.hook_command('재입장', cmd_rejoin, help=help_str)
xchat.hook_command('리조인', cmd_rejoin, help=help_str)

### baroslized start ###
func_start('')


# EndOfFile
